/* inverse_thomas
 *  Copyright (C) 2000 Luc Brun
 *  email: brun@leri.univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#include <stdio.h>
#include "distance.h"
#include "types.h"
#include "macros.h"
#define DEBUG 1
void debug(cubeRGB distance,cubeRGB classe,cubeRGB
	   distance_maj,cubeRGB classe_maj,int *table)
{
    int i,j,k;
    int c,cm;
    int rc,gc,bc,rcm,gcm,bcm;
    for(i=0;i<TAILLE_CUBE;i++)
	    for(j=0;j<TAILLE_CUBE;j++)
		    for(k=0;k<TAILLE_CUBE;k++)
			    if(distance[i][j][k] != distance_maj[i][j][k])
				    {
					c= classe[i][j][k];
					cm = classe_maj[i][j][k];
					rc =*(table+3*c);
					gc =*(table+3*c+1);
					bc =*(table+3*c+2);
					rcm =*(table+3*cm);
					gcm =*(table+3*cm+1);
					bcm =*(table+3*cm+2);
					printf("\n\n\n BUG !! ");
					printf("dist = %d, dist maj =%d\n",distance[i][j][k],distance_maj[i][j][k]);
					printf("classe = %d :(%d,%d,%d), classe maj =%d: (%d,%d,%d)\n",c,rc,gc,bc,cm,rcm,gcm,bcm);
					printf("i =%d,j=%d,k=%d\n",i,j,k);
				    }
}
bouleen boucle_bleu(int* gdist,int* binc,int* bq,int rc,int gc,int
		    index,int deux_x_2,cubeRGB distance,cubeRGB
		    classe,delaunay del) 
{
    int bdist = *gdist;
    int bxx = *binc;
    int detecte = faux;
    int fin = faux;
    int bc = *bq;
    int *dist = &(distance[rc][gc][bc]);
    int *class  = &(classe[rc][gc][bc]);

    while((bc<TAILLE_CUBE)&&(!fin))
	    {

		if(*dist <bdist)
			{
			    if(detecte)
				    fin = vrai;
			}
		else
			{
			    if((!detecte)&&(bc>*bq))
				    {
					*bq = bc;
					*binc = bxx;
					*gdist = bdist;
				    }
			    detecte = vrai;
			    *dist = bdist;
			    del[*class][index]=del[index][*class]= vrai;
			    *class = index;
			}
		bxx+= deux_x_2;
		bdist+=bxx;

		bc++;
		dist++;
		class++;
	    }
    bdist = *gdist-*binc;
    bxx = *binc-deux_x_2;
    fin = faux;
    bc = *bq-1;
    dist =  &(distance[rc][gc][bc]);
    class = &(classe[rc][gc][bc]);

    while((bc>=0)&&(!fin))
	    {

		if(*dist < bdist)
			{
			    if(detecte)
				    fin = vrai;
			}
		else
			{
			    if((!detecte)&&(bc>*bq))
				    {
					*bq = bc;
					*binc = bxx;
					*gdist = bdist;
				    }
			    detecte = vrai;
			    *dist = bdist;
			    del[*class][index]=del[index][*class]= vrai;
			    *class = index;
			}

		bdist -= bxx;
		bxx -= deux_x_2;
		bc--;
		dist--;
		class--;
	    }
    return(detecte);
}


void init_image_dist(int ri,int gi,int bi,cubeRGB distance,cubeRGB
		     classe,int nb_couleur,delaunay del)
{
    int i,j;
    int rq,gq,bq;
    int x = REDUCTION;
    int x_2 = x*x;
    int deux_x_2 = 2*x_2;
    int gdist,bdist;
    int rdist = (ri-x/2)*(ri-x/2)+ (gi-x/2)*(gi-x/2)+ (bi-x/2)*(bi-x/2);
    int rinc = 2*x*(x-ri);
    int ginc = 2*x*(x-gi);
    int binc = 2*x*(x-bi);
    int rxx,gxx,bxx;
    int *dist = (int*)distance;
    int* class = (int*)classe;

    for(i=0;i<nb_couleur;i++)
	    for(j=0;j<nb_couleur;j++)
		    del[i][j] =faux;
    rxx = rinc;
    for(rq=0;rq<TAILLE_CUBE;rq++)
	    {
		gdist = rdist;
		gxx = ginc;
		for(gq=0;gq<TAILLE_CUBE;gq++)
			{
			    bdist = gdist;
			    bxx= binc;
			    for(bq=0;bq<TAILLE_CUBE;bq++)
				    {
					
					*dist = bdist;
					*class = 0;
					bdist += bxx;
					bxx += deux_x_2;
					dist++;
					class++;
				    }
			    gdist += gxx;
			    gxx += deux_x_2;
			}
		rdist += rxx;
		rxx += deux_x_2;
	    }
}
    
    
void image_dist(int* table,int nb_couleur,cubeRGB classe,cubeRGB
		distance,delaunay del)
{
  int* table_courante;
  int r,g,b;
  int rq,gq,bq,cbq;
  int rc,gc,bc;
  int x = REDUCTION;
  int x_2 = x*x;
  int deux_x_2 = 2*x_2;
  int dist,rdist,gdist,bdist;
  int rinc,ginc,binc,crinc,cbinc,cginc;
  int rxx,gxx,bxx;
  int index;
  bouleen fin,detecte,a_detecte,detecte_ligne,fin_g;
  
  init_image_dist(*table,*(table+1),*(table+2),distance,classe,nb_couleur,del);
    
    for(index=1;index<nb_couleur;index++)
	    {
/*		printf("je traite la couleur : %d\n",index);*/
		table_courante = table+3*index;
		
		r = *table_courante;
		g = *(table_courante+1);
		b = *(table_courante+2);
		
		rq = r>>K_REDUCTION;
		gq = g>>K_REDUCTION;
		cbq=bq = b>>K_REDUCTION;
		
		crinc=rinc = 2*x*(rq*x-r);
		cginc=ginc = 2*x*(gq*x-g);
		cbinc=binc = 2*x*(bq*x-b);
		
		rdist = (r-(rq*x+x/2));
		gdist = (g-(gq*x+x/2));
		bdist = (b-(bq*x+x/2));
		
		dist = rdist*rdist+ gdist*gdist+bdist*bdist;
		
		rdist = dist;
		rxx = rinc;
		rc = rq;
		fin = faux;
		a_detecte = faux;
		while((rc<TAILLE_CUBE)&&(!fin))
			{
			    gdist = rdist;
			    gxx = ginc;
			    binc = cbinc;
			    bq= cbq;
			    detecte = faux;
			    fin_g = faux;
			    gc = gq;
			    while((gc<TAILLE_CUBE)&&(!fin_g))
				    {
					detecte_ligne = boucle_bleu(&gdist,&binc,&bq,rc,gc,index,deux_x_2,distance,classe,del);
					detecte = detecte || detecte_ligne;
					fin_g = !detecte_ligne&&detecte;

					gxx += deux_x_2;
					gdist += gxx;

					gc++;
				    }

			    gdist = rdist-ginc;
			    gxx = ginc-deux_x_2;
			    binc = cbinc;
			    bq= cbq;
			    gc= gq-1;
			    fin_g = faux;
			    while((gc >=0)&&(!fin_g))
				    {
					detecte_ligne = boucle_bleu(&gdist,&binc,&bq,rc,gc,index,deux_x_2,distance,classe,del);
					detecte = detecte || detecte_ligne;  
				  	fin_g = !detecte_ligne&&detecte;

					gdist -= gxx;
					gxx -= deux_x_2;
					gc--;
				    }
			    rxx += deux_x_2;
			    rdist += rxx;

			    rc++;
			    a_detecte= a_detecte || detecte;
			    fin = (!detecte)&&a_detecte;
			}
		rdist = dist-rinc;
		rxx = rinc-deux_x_2;
		rc =rq-1;
		fin = faux;
		while((rc>=0)&&(!fin))
			{
			    gdist = rdist;
			    gxx = ginc;
			    binc = cbinc;
			    bq= cbq;
			    detecte = faux;
			    fin_g = faux;
			    gc=gq;
			    while((gc<TAILLE_CUBE)&&(!fin_g))
				    {
					detecte_ligne = boucle_bleu(&gdist,&binc,&bq,rc,gc,index,deux_x_2,distance,classe,del);
					detecte = detecte ||detecte_ligne; 
				  	fin_g = !detecte_ligne&&detecte;

					gxx += deux_x_2;
					gdist += gxx;
					gc++;
					
				    }
			    gdist = rdist-ginc;
			    gxx = ginc-deux_x_2;
			    binc = cbinc;
			    bq= cbq;
			    gc= gq-1;
			    fin_g = faux;
			    while((gc >=0)&&(!fin_g))
				    {
					detecte_ligne = boucle_bleu(&gdist,&binc,&bq,rc,gc,index,deux_x_2,distance,classe,del);
					detecte = detecte ||detecte_ligne;  
			  		fin_g = !detecte_ligne&&detecte;

					gdist -= gxx;
					gxx -= deux_x_2;
					gc--;
				    }
			    rdist -= rxx;
			    rxx -= deux_x_2;
			    rc--;
			    a_detecte = a_detecte || detecte;
			    fin = (!detecte)&&a_detecte;
			}

	    }
}
bouleen actualise_boucle_bleu(int* gdist,int* binc,int* bq,int rc,int gc,int
		    index,int point_change,int deux_x_2,cubeRGB distance,cubeRGB
		    classe,delaunay del) 
{
    int bdist = *gdist;
    int bxx = *binc;
    int detecte = faux;
    int fin = faux;
    int bc = *bq;
    int *dist = &(distance[rc][gc][bc]);
    int *class  = &(classe[rc][gc][bc]);

    while((bc<TAILLE_CUBE)&&(!fin))
	    {

		if((*dist <bdist)&&(*class != index)&&(*class !=point_change))
			{
			    if(index == point_change)
				    del[*class][index]=del[index][*class]= vrai;
			    if(detecte)
				    fin = vrai;
			}
		else
			{
			    if((!detecte)&&(bc>*bq))
				    {
					*bq = bc;
					*binc = bxx;
					*gdist = bdist;
				    }
			    detecte = vrai;
			    *dist = bdist;
			    *class = index;
			}
		bxx+= deux_x_2;
		bdist+=bxx;

		bc++;
		dist++;
		class++;
	    }
    bdist = *gdist-*binc;
    bxx = *binc-deux_x_2;
    fin = faux;
    bc = *bq-1;
    dist =  &(distance[rc][gc][bc]);
    class = &(classe[rc][gc][bc]);

    while((bc>=0)&&(!fin))
	    {

		if((*dist < bdist)&&(*class != index)&&(*class != point_change))
			{
			    if(index == point_change)
				    del[*class][index]=del[index][*class]= vrai;
			    if(detecte)
					fin = vrai;

			}
		else
			{
			    if((!detecte)&&(bc>*bq))
				    {
					*bq = bc;
					*binc = bxx;
					*gdist = bdist;
				    }
			    detecte = vrai;
			    *dist = bdist;
			    *class = index;
			}

		bdist -= bxx;
		bxx -= deux_x_2;
		bc--;
		dist--;
		class--;
	    }
    return(detecte);
}

void actualise_image_dist(int* table,int nb_couleur,int point_act,int point_change,cubeRGB classe,cubeRGB distance,delaunay
		     del)
{
    int* table_courante;
    int r,g,b;
    int rq,gq,bq,cbq;
    int rc,gc,bc;
    int x = REDUCTION;
    int x_2 = x*x;
    int deux_x_2 = 2*x_2;
    int dist,rdist,gdist,bdist;
    int rinc,ginc,binc,crinc,cbinc,cginc;
    int rxx,gxx,bxx;
    int i,index;
    bouleen fin,detecte,a_detecte,detecte_ligne,fin_g;

    if(point_act == point_change)
	    {
		for(i=0;i<nb_couleur;i++)
			del[i][point_change]=del[point_change][i] =faux;
	    }
    
    index = point_act;


    table_courante = table+3*index;
    
    r = *table_courante;
    g = *(table_courante+1);
    b = *(table_courante+2);
    
    rq = r>>K_REDUCTION;
    gq = g>>K_REDUCTION;
    cbq=bq = b>>K_REDUCTION;
    
    crinc=rinc = 2*x*(rq*x-r);
    cginc=ginc = 2*x*(gq*x-g);
    cbinc=binc = 2*x*(bq*x-b);
    
    rdist = (r-(rq*x+x/2));
    gdist = (g-(gq*x+x/2));
    bdist = (b-(bq*x+x/2));
    
    dist = rdist*rdist+ gdist*gdist+bdist*bdist;
    
    rdist = dist;
    rxx = rinc;
    rc = rq;
    fin = faux;
    a_detecte = faux;
    while((rc<TAILLE_CUBE)&&(!fin))
	    {
		gdist = rdist;
		gxx = ginc;
		binc = cbinc;
		bq= cbq;
		detecte = faux;
		fin_g = faux;
		gc = gq;
		while((gc<TAILLE_CUBE)&&(!fin_g))
			{
			    detecte_ligne = actualise_boucle_bleu(&gdist,&binc,&bq,rc,gc,index,point_change,deux_x_2,distance,classe,del);
			    detecte = detecte || detecte_ligne;
			    fin_g = !detecte_ligne&&detecte;
			    
			    gxx += deux_x_2;
			    gdist += gxx;
			    
			    gc++;
			}
		
		gdist = rdist-ginc;
		gxx = ginc-deux_x_2;
		binc = cbinc;
		bq= cbq;
		gc= gq-1;
		fin_g = faux;
		while((gc >=0)&&(!fin_g))
			{
			    detecte_ligne = actualise_boucle_bleu(&gdist,&binc,&bq,rc,gc,index,point_change,deux_x_2,distance,classe,del);
			    detecte = detecte || detecte_ligne;  
			    fin_g = !detecte_ligne&&detecte;
			    
			    gdist -= gxx;
			    gxx -= deux_x_2;
			    gc--;
			}
		rxx += deux_x_2;
		rdist += rxx;
		
		rc++;
		a_detecte= a_detecte || detecte;
		fin = (!detecte)&&a_detecte;
	    }
    rdist = dist-rinc;
    rxx = rinc-deux_x_2;
    rc =rq-1;
    fin = faux;
    while((rc>=0)&&(!fin))
	    {
		gdist = rdist;
		gxx = ginc;
		binc = cbinc;
		bq= cbq;
		detecte = faux;
		fin_g = faux;
		gc=gq;
		while((gc<TAILLE_CUBE)&&(!fin_g))
			{
			    detecte_ligne = actualise_boucle_bleu(&gdist,&binc,&bq,rc,gc,index,point_change,deux_x_2,distance,classe,del);
			    detecte = detecte ||detecte_ligne; 
			    fin_g = !detecte_ligne&&detecte;
			    
			    gxx += deux_x_2;
			    gdist += gxx;
			    gc++;
			    
			}
		gdist = rdist-ginc;
		gxx = ginc-deux_x_2;
		binc = cbinc;
		bq= cbq;
		gc= gq-1;
		fin_g = faux;
		while((gc >=0)&&(!fin_g))
			{
			    detecte_ligne = actualise_boucle_bleu(&gdist,&binc,&bq,rc,gc,index,point_change,deux_x_2,distance,classe,del);
			    detecte = detecte ||detecte_ligne;  
			    fin_g = !detecte_ligne&&detecte;
			    
			    gdist -= gxx;
			    gxx -= deux_x_2;
			    gc--;
			}
		rdist -= rxx;
		rxx -= deux_x_2;
		rc--;
		a_detecte = a_detecte || detecte;
		fin = (!detecte)&&a_detecte;
		
		
	    }
}
void ameliorer_table(int *table,Comp_rgb * image,int hauteur,int largeur,int nb_de_couleur,cubeRGB classe)
{
    cubeRGB classe_ex,distance,distance_ex;
    int nouvelle_table[NB_MAX_DE_COULEUR][3];
    int card,somme[NB_MAX_DE_COULEUR];
    int R,G,B,RQ,GQ,BQ,RT,GT,BT;
    Comp_rgb* pixel= image;
    int *tablei,class;
    int i,j;
    bouleen fin= faux;
    int moyenne[NB_MAX_DE_COULEUR][3],moyenne_old[NB_MAX_DE_COULEUR][3];
    int minimum[NB_MAX_DE_COULEUR],min=256*256*256;
    int RM,GM,BM;
    int dist;
    bouleen changement[NB_MAX_DE_COULEUR];
    int diff;
    delaunay del;
    int nb_point_change;
    int point_change;
/* initialisation des differents tableaux */

    for(i=0;i<nb_de_couleur;i++)
	    {
		somme[i]=0;
		for(j=0;j<3;j++)
			{
			    moyenne[i][j] = 0;
			    moyenne_old[i][j]=min;
			}
	    }
    image_dist(table,nb_de_couleur,classe,distance,del);    

    while(!fin)
	    {
		/* On calcule les moyennes */
		pixel = image;
		for(i=0;i<hauteur;i++)
			for(j=0;j<largeur;j++)
				{
				    R = *pixel;
				    G = *(pixel+1);
				    B = *(pixel+2);
				    RQ = R>>K_REDUCTION;
				    GQ = G>>K_REDUCTION;
				    BQ = B>>K_REDUCTION;
				    class = classe[RQ][GQ][BQ];
				    moyenne[class][0] += R;
				    moyenne[class][1] += G;
				    moyenne[class][2] += B;
				    somme[class]++;
				    pixel +=3;
				    
				}
		for(i=0;i<nb_de_couleur;i++)
			{
			    minimum[i] = min;
			    changement[i] = faux;
			    for(j=0;j<3;j++)
				    {
					moyenne[i][j] /= somme[i];
					changement[i] =	changement[i]||(moyenne_old[i][j] != moyenne[i][j]); 
				    }
			}
		/* On calcule le point de l'image le plus proche de */
		/* chaque moyenne */
		pixel = image;
		for(i=0;i<hauteur;i++)
			for(j=0;j<largeur;j++)
				{
				    R = *pixel;
				    G = *(pixel+1);
				    B = *(pixel+2);
				    RQ = R>>K_REDUCTION;
				    GQ = G>>K_REDUCTION;
				    BQ = B>>K_REDUCTION; 
				    class = classe[RQ][GQ][BQ];
				    if(changement[class])
					    {
						RM = moyenne[class][0];
						GM = moyenne[class][1];
						BM = moyenne[class][2];
						dist = (R-RM)*(R-RM)+ (G-GM)*(G-GM)+(B-BM)*(B-BM);
						if(dist < minimum[class])
							{
							    minimum[class] = dist;
							    nouvelle_table[class][0]=R;
							    nouvelle_table[class][1]=G;
							    nouvelle_table[class][2]=B;
							}
					    }
						pixel +=3;
				}
		/* On reinitialise pour une nouvelle boucle */
		tablei = table;
		fin = vrai;
		nb_point_change=0;
		for(i=0;i<nb_de_couleur;i++)
			{
			    


			    R= nouvelle_table[i][0];
			    G= nouvelle_table[i][1];
			    B= nouvelle_table[i][2];

			    RT = *tablei;
			    GT = *(tablei+1);
			    BT = *(tablei+2);	
#ifdef DEBUG
			    printf("i=%d ,(RT,GT,BT)=(%d,%d,%d)-->(R,G,B)=(%d,%d,%d); somme =%d\n",i,RT,GT,BT,R,G,B,somme[i]);
			    printf("i=%d,RM,GM,BM =(%d,%d,%d)\n",i,moyenne[i][0],moyenne[i][1],moyenne[i][2]);
#endif
			    fin = fin&&(-4<R-RT)&&(R-RT<4);
			    fin = fin&&(-4<G-GT)&&(G-GT<4);
			    fin = fin&&(-4<B-BT)&&(B-BT<4);	
			    if(( R!=RT)||(G!=GT)||(B!=BT))
				    {
					nb_point_change++;
					point_change = i;
				    }
			    *tablei = R;
			    *(tablei+1)= G;
			    *(tablei+2)= B;

			    for(j=0;j<3;j++)
				    moyenne_old[i][j]=moyenne[i][j];
			    for(j=0;j<3;j++)
				    moyenne[i][j]=0;
			    
			    somme[i] =0;
			    tablei +=3;
			}
		if(nb_point_change > 1)
			image_dist(table,nb_de_couleur,classe,distance,del);
		else
			if(nb_point_change ==1)
				{
				    printf("pt change : %d\n",point_change);
				    for(i=0;i<nb_de_couleur;i++)
					    {
						for(j=0;j<nb_de_couleur;j++)					    
							printf(" %d",del[i][j]);
						printf("\n");
					    }
				    for(i=0;i<nb_de_couleur;i++)
					    if(del[point_change][i])
						    actualise_image_dist(table,nb_de_couleur,i,point_change,classe,distance,del);

				    actualise_image_dist(table,nb_de_couleur,point_change,point_change,classe,distance,del);
				}
/*		maj_image_dist(table,nb_de_couleur,classe,d,distance,distance_ex);*/


/*		debug(distance_ex,classe_ex,distance,classe,table);*/
#ifdef DEBUG
		printf("\n\n");
#endif
		printf("j'itere ds distance.c\n");
	    }
}




























